aboutsummaryrefslogtreecommitdiff
path: root/test/docker-in-docker
diff options
context:
space:
mode:
Diffstat (limited to 'test/docker-in-docker')
-rw-r--r--test/docker-in-docker/docker_retry.sh32
-rw-r--r--test/docker-in-docker/scenarios.json7
-rw-r--r--test/docker-in-docker/test-scripts/docker-test-init.sh26
3 files changed, 64 insertions, 1 deletions
diff --git a/test/docker-in-docker/docker_retry.sh b/test/docker-in-docker/docker_retry.sh
new file mode 100644
index 0000000..cc35fbb
--- /dev/null
+++ b/test/docker-in-docker/docker_retry.sh
@@ -0,0 +1,32 @@
+#!/bin/bash
+
+set -e
+
+# Optional: Import test library
+source dev-container-features-test-lib
+
+# Definition specific tests
+check "docker-buildx" docker buildx version
+check "docker-ps" docker ps
+
+sleep 5s
+
+# Stop docker
+pkill dockerd
+pkill containerd
+
+sleep 5s
+
+set +e
+ docker_ok_code="$(docker info > /dev/null 2>&1; echo $?)"
+set -e
+
+check "docker-not-running" bash -c "[[ ${docker_ok_code} == 1 ]]"
+
+# Testing retry logic
+./test-scripts/docker-test-init.sh
+
+check "docker-started-after-retries" docker ps
+
+# Report result
+reportResults
diff --git a/test/docker-in-docker/scenarios.json b/test/docker-in-docker/scenarios.json
index 9c44478..525ce69 100644
--- a/test/docker-in-docker/scenarios.json
+++ b/test/docker-in-docker/scenarios.json
@@ -67,6 +67,11 @@
}
},
"remoteUser": "node"
+ },
+ "docker_retry": {
+ "image": "ubuntu:focal",
+ "features": {
+ "docker-in-docker": {}
+ }
}
-
}
diff --git a/test/docker-in-docker/test-scripts/docker-test-init.sh b/test/docker-in-docker/test-scripts/docker-test-init.sh
new file mode 100644
index 0000000..b213fb4
--- /dev/null
+++ b/test/docker-in-docker/test-scripts/docker-test-init.sh
@@ -0,0 +1,26 @@
+#!/bin/sh
+#-------------------------------------------------------------------------------------------------------------
+# Copyright (c) Microsoft Corporation. All rights reserved.
+# Licensed under the MIT License. See https://go.microsoft.com/fwlink/?linkid=2090316 for license information.
+#-------------------------------------------------------------------------------------------------------------
+
+retry_count=0
+docker_ok="false"
+
+until [ "${docker_ok}" = "true" ] || [ "${retry_count}" -eq "5" ];
+do
+ if [ "${retry_count}" -eq "3" ]; then
+ echo "Starting docker after 3 retries..."
+ /usr/local/share/docker-init.sh
+ fi
+
+ set +e
+ docker info > /dev/null 2>&1 && docker_ok="true"
+
+ if [ "${docker_ok}" != "true" ]; then
+ echo "(*) Failed to start docker, retrying in 5s... Retry count: ${retry_count}"
+ retry_count=`expr $retry_count + 1`
+ sleep 1s
+ fi
+ set -e
+done \ No newline at end of file